2331: [SCOI2011]地板 插头DP

2024-02-29 01:50
文章标签 dp 插头 2331 地板 scoi2011

本文主要是介绍2331: [SCOI2011]地板 插头DP,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

国际惯例的题面:

十分显然的插头DP。由于R*C<=100,所以min(R,C)<=10,然后就可以愉悦地状压啦。
我们用三进制状压,0表示没有插头,1表示有一个必须延伸至少一格且拐弯的插头,2表示有一个必须延伸一格且不可以拐弯的插头。
转移的话就十分显然了。
00->22,表示用这个格子作为开始的拐角。
00->10,表示用这个格子向下延伸。
00->01,表示用这个格子向右延伸。
01->10,表示这个格子连接上下。
01->02,表示在这个格子作为中间的拐角。
02->20,表示这个格子连接上下。
02->00,表示这个格子作为某个地板的终点。
10->01,表示这个格子连接左右。
10->20,表示在这个格子作为中间的拐角。
11->00,表示这个格子作为结束的拐角。
20->00,表示这个格子作为某个地板的终点。
20->02,表示这个格子连接左右。
(插头DP的本质就是分类讨论,所以麻烦也没办法,想明白就很容易了)
然后就是实现了。我是用unordered_map存储状态,同时先找到第一个可以放东西的位置开始DP,统计答案的时候统计第n+1行没有插头的状态。

代码:

 1 #pragma GCC optimize(2)
 2 #include<cstdio>
 3 #include<cstring>
 4 #include<tr1/unordered_map>
 5 using namespace std;
 6 using namespace tr1;
 7 const int maxn=1e2+1e2;
 8 const int mod=20110520;
 9 
10 int sta[maxn],nxt[maxn];
11 char in[maxn][maxn]; // in == 1 means empty .
12 int n,m,cur,fx,fy;
13 unordered_map<int,int> f[2];
14 
15 inline void unzip(int* sta,int ss) {
16     for(int i=m+1;i;i--) sta[i] = ss % 3 , ss /= 3;
17 }
18 inline int zip(int* sta) {
19     int ret = 0;
20     for(int i=1;i<=m+1;i++) ret = ret * 3 + sta[i];
21     return ret;
22 }
23 
24 inline void core_trans(unordered_map<int,int> &dst,int x,int y,int add) {
25     memcpy(nxt,sta,sizeof(int)*(m+2));
26     if( !in[x][y] ) { // not empty .
27         if( sta[y] == 0 && sta[y+1] == 0 ) ( dst[zip(nxt)] += add ) %= mod;
28         return;
29     }
30     if( sta[y] == 0 ) {
31         if( sta[y+1] == 0 ) {
32             nxt[y] = 2 , nxt[y+1] = 2 , ( dst[zip(nxt)] += add ) %= mod;
33             nxt[y] = 1 , nxt[y+1] = 0 , ( dst[zip(nxt)] += add ) %= mod;
34             nxt[y] = 0 , nxt[y+1] = 1 , ( dst[zip(nxt)] += add ) %= mod;
35         } else if( sta[y+1] == 1 ) {
36             nxt[y] = 1 , nxt[y+1] = 0 , ( dst[zip(nxt)] += add ) %= mod;
37             nxt[y] = 0 , nxt[y+1] = 2 , ( dst[zip(nxt)] += add ) %= mod;
38         } else if( sta[y+1] == 2 ) {
39             nxt[y] = 2 , nxt[y+1] = 0 , ( dst[zip(nxt)] += add ) %= mod;
40             nxt[y] = 0 , nxt[y+1] = 0 , ( dst[zip(nxt)] += add ) %= mod;
41         }
42     } else if( sta[y] == 1 ) {
43         if( sta[y+1] == 0 ) {
44             nxt[y] = 0 , nxt[y+1] = 1 , ( dst[zip(nxt)] += add ) %= mod;
45             nxt[y] = 2 , nxt[y+1] = 0 , ( dst[zip(nxt)] += add ) %= mod;
46         } else if( sta[y+1] == 1 ) nxt[y] = 0 , nxt[y+1] = 0 , ( dst[zip(nxt)] += add ) %= mod;
47     } else if( sta[y] == 2 ) {
48         if( sta[y+1] == 0 ) {
49             nxt[y] = 0 , nxt[y+1] = 0 , ( dst[zip(nxt)] += add ) %= mod;
50             nxt[y] = 0 , nxt[y+1] = 2 , ( dst[zip(nxt)] += add ) %= mod;
51         }
52     }
53 }
54 inline void trans(const unordered_map<int,int> &sou,unordered_map<int,int> &dst,int x,int y) {
55     dst.clear();
56     for(unordered_map<int,int>::const_iterator it=sou.begin();it!=sou.end();it++) if( it->second ) {
57         unzip(sta,it->first) , core_trans(dst,x,y,it->second);
58     }
59 }
60 inline void transline(const unordered_map<int,int> &sou,unordered_map<int,int> &dst) {
61     dst.clear();
62     for(unordered_map<int,int>::const_iterator it=sou.begin();it!=sou.end();it++) if( it->second && ! ( it->first % 3 ) ) {
63         dst[it->first/3] = it->second;
64     }
65 }
66 
67 inline void revert() { // make m <= n .
68     static char tp[maxn][maxn];
69     memcpy(tp,in,sizeof(in)) , memset(in,0,sizeof(in));
70     for(int i=1;i<=n;i++) for(int j=1;j<=m;j++) in[j][i] = tp[i][j];
71     swap(n,m);
72 }
73 
74 int main() {
75     scanf("%d%d",&n,&m) , fx = -1 , fy = -1;
76     for(int i=1;i<=n;i++) {
77         scanf("%s",in[i]+1);
78         for(int j=1;j<=m;j++) in[i][j] = in[i][j] == '_';
79     }
80     
81     if( n < m ) revert();
82     for(int i=1;i<=n&&!~fx;i++) for(int j=1;j<=m&&!~fx;j++) if(in[i][j]) fx = i , fy = j;
83     if( !~fx ) return puts("1") , 0; // nothing to do .
84     sta[fy] = 0 , sta[fy+1] = 1 , f[cur][zip(sta)] = 1;
85     sta[fy] = 1 , sta[fy+1] = 0 , f[cur][zip(sta)] = 1;
86     sta[fy] = sta[fy+1] = 2 , f[cur][zip(sta)] = 1;
87     for(int j=fy+1;j<=m;j++) trans(f[cur],f[cur^1],fx,j) , cur ^= 1;
88     transline(f[cur],f[cur^1]) , cur ^= 1;
89     
90     for(int i=fx+1;i<=n;i++) {
91         for(int j=1;j<=m;j++)
92             trans(f[cur],f[cur^1],i,j) , cur ^= 1;
93         transline(f[cur],f[cur^1]) , cur ^= 1;
94     }
95     
96     printf("%d\n",f[cur][0]);
97     
98     return 0;
99 }
View Code



たいせつなきみのために ぼくにできるいちばんのことは
为了最重要的你 我所能做的最好的事
約束を忘れること君への想い消し去ること
就是忘却与你的约定抹去对你的思念
沈む夕日暮れてく空 夜の帳舞い降りる頃
渐渐归隐大地的夕阳 夜幕降临整个天空 夜的气息轻盈飘落之时
僕は目を閉じて それは闇に溶けるように 滲んで消えた
我闭目去感受 一切就像溶入暗影一样 渗透进去消散无痕了

未来なんていらないよ
未来(明日)什么的已经不需要了吧
君が側にいる過去のままで
因为有你一直陪伴我的往昔(昨日)

转载于:https://www.cnblogs.com/Cmd2001/p/9043222.html

这篇关于2331: [SCOI2011]地板 插头DP的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/757236

相关文章

hdu4826(三维DP)

这是一个百度之星的资格赛第四题 题目链接:http://acm.hdu.edu.cn/contests/contest_showproblem.php?pid=1004&cid=500 题意:从左上角的点到右上角的点,每个点只能走一遍,走的方向有三个:向上,向下,向右,求最大值。 咋一看像搜索题,先暴搜,TLE,然后剪枝,还是TLE.然后我就改方法,用DP来做,这题和普通dp相比,多个个向上

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu4865(概率DP)

题意:已知前一天和今天的天气概率,某天的天气概率和叶子的潮湿程度的概率,n天叶子的湿度,求n天最有可能的天气情况。 思路:概率DP,dp[i][j]表示第i天天气为j的概率,状态转移如下:dp[i][j] = max(dp[i][j, dp[i-1][k]*table2[k][j]*table1[j][col] )  代码如下: #include <stdio.h>#include

usaco 1.1 Broken Necklace(DP)

直接上代码 接触的第一道dp ps.大概的思路就是 先从左往右用一个数组在每个点记下蓝或黑的个数 再从右到左算一遍 最后取出最大的即可 核心语句在于: 如果 str[i] = 'r'  ,   rl[i]=rl[i-1]+1, bl[i]=0 如果 str[i] = 'b' ,  bl[i]=bl[i-1]+1, rl[i]=0 如果 str[i] = 'w',  bl[i]=b

uva 10154 DP 叠乌龟

题意: 给你几只乌龟,每只乌龟有自身的重量和力量。 每只乌龟的力量可以承受自身体重和在其上的几只乌龟的体重和内。 问最多能叠放几只乌龟。 解析: 先将乌龟按力量从小到大排列。 然后dp的时候从前往后叠,状态转移方程: dp[i][j] = dp[i - 1][j];if (dp[i - 1][j - 1] != inf && dp[i - 1][j - 1] <= t[i]

uva 10118 dP

题意: 给4列篮子,每次从某一列开始无放回拿蜡烛放入篮子里,并且篮子最多只能放5支蜡烛,数字代表蜡烛的颜色。 当拿出当前颜色的蜡烛在篮子里存在时,猪脚可以把蜡烛带回家。 问最多拿多少只蜡烛。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cs

uva 10069 DP + 大数加法

代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <queue>#include <map>#include <cl

uva 10029 HASH + DP

题意: 给一个字典,里面有好多单词。单词可以由增加、删除、变换,变成另一个单词,问能变换的最长单词长度。 解析: HASH+dp 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#inc

XTU 1233 n个硬币连续m个正面个数(dp)

题面: Coins Problem Description: Duoxida buys a bottle of MaiDong from a vending machine and the machine give her n coins back. She places them in a line randomly showing head face or tail face o

dp算法练习题【8】

不同二叉搜索树 96. 不同的二叉搜索树 给你一个整数 n ,求恰由 n 个节点组成且节点值从 1 到 n 互不相同的 二叉搜索树 有多少种?返回满足题意的二叉搜索树的种数。 示例 1: 输入:n = 3输出:5 示例 2: 输入:n = 1输出:1 class Solution {public int numTrees(int n) {int[] dp = new int